<?php
// IP Blocker plugin for DirectAdmin created by Dravu
class blockip {
	// Create variables to hold the domain info
	var $getuserdir;
	var $getdomains;
	var $domain;
	var $domains;

	// Just a little something to hold the query info
	var $get;
	
	// Variables for submitted info
	var $action;
	var $pulltogether;
	var $information;
	var $multipleips;
	
	// Variables for reading/writing the .htaccess file
	var $htaccess;
	var $handle;
	var $info;
	
	// Viewing variables, mainly for the syncing part
	var $blockedips;
	var $numofips;
	
	// Start off getting the general information
	function __construct(){
		$this->error = array();
		$this->domains = array();
		$this->information = array();
		parse_str($_SERVER["QUERY_STRING"],$this->get);
		$this->getuserdir = "{$_SERVER['HOME']}";
		$this->getdomains = opendir($this->getuserdir."/domains/");
		while(($this->domain = readdir($this->getdomains)) !== false){
			if($this->domain != ".." && is_dir($this->getuserdir."/domains/".$this->domain."/public_html")){
				$this->domains[]=$this->domain;
			}
		}
	}
	
	// Basically pull and organize the submitted information
	function pulltogether(){
		$this->pulltogether = explode('&',$_SERVER['POST']);
		for($i=0;$i<count($this->pulltogether);$i++){
			if(substr($this->pulltogether[$i],6) != "action" && substr($this->pulltogether[$i],-3) == "=on"){
				$this->information[] = substr($this->pulltogether[$i],0,-3);
			} else if(substr($this->pulltogether[$i],0,2) == "ip"){
				if(strpos($this->pulltogether[$i],"+") !== false){
					$this->multipleips = explode("+",substr($this->pulltogether[$i],3));
					for($j=0;$j<count($this->multipleips);$j++){
						$this->information[] = $this->multipleips[$j];
					}
				} else {
					$this->information[] = trim(substr($this->pulltogether[$i],3));
				}
			} else if(substr($this->pulltogether[$i],0,6) == "action"){
				$this->action = str_replace("action=","",$this->pulltogether[$i]);
			}
		}
	}
	
	// Let's add/remove some IPs!
	function doit(){
		for($j=0;$j<count($this->domains);$j++){
			$this->htaccess = $this->getuserdir."/domains/".$this->domains[$j]."/public_html/.htaccess";
			$this->createfile = (file_exists($this->htaccess)) ? false : true;
			if(!$this->createfile && filesize($this->htaccess) != 0){
				$this->handle = fopen($this->htaccess, "r");
				$this->info = fread($this->handle, filesize($this->htaccess));
				fclose($this->handle);
			} else {
				$this->info = "";
			}
			$this->handle = fopen($this->htaccess, "w+");
			if(eregi("\# IP Blocker(.+)\# End IP Blocker",$this->info)){
				for($k=0;$k<count($this->information);$k++){
					if($this->action == "adding" && !strpos($this->info,"deny from ".$this->information[$k]) && (strlen($this->information[$k])>5 && ip2long($this->information[$k]) != -1 && ip2long($this->information[$k]) !== false)){
						$this->info = eregi_replace("\# IP Blocker\norder allow,deny(.+)\# End IP Blocker","# IP Blocker\norder allow,deny\ndeny from ".$this->information[$k]."\\1# End IP Blocker",$this->info);
					} else if($this->action == "removing" && strpos($this->info,"deny from ".$this->information[$k])!==false && strlen($this->information[$k])>5){
						$this->info = str_replace("\ndeny from ".$this->information[$k],"",$this->info);
						$this->error[] = $this->information[$k];
					} else if($this->action == "removeipblocker"){
						$this->info = eregi_replace("\n\# IP Blocker(.+)\# End IP Blocker","",$this->info);
						$this->info = eregi_replace("\# IP Blocker(.+)\# End IP Blocker","",$this->info);
					}
				}
				fwrite($this->handle,$this->info);
			} else if($this->action == "adding"){
				for($k=0;$k<count($this->information);$k++){
					if(strlen($this->information[$k])>5 && ip2long($this->information[$k]) != -1 && ip2long($this->information[$k]) !== false){
						$this->info = "\n# IP Blocker\norder allow,deny\ndeny from ".$this->information[$k]."\nallow from all\n# End IP Blocker";
						fwrite($this->handle,$this->info);
					}
				}
			} else {
				fwrite($this->handle,$this->info);
			}
			fclose($this->handle);
			if($this->createfile){
				chgrp($this->htaccess,$_SERVER['USER']);
				chown($this->htaccess,$_SERVER['USER']);
				chmod($this->htaccess,0755);
			}
		}
	}
	
	// Lets return the current blocked IPs and sync them among the domains if multiple are detected
	function viewblocks(){
		for($j=0;$j<count($this->domains);$j++){
			$this->htaccess = $this->getuserdir."/domains/".$this->domains[$j]."/public_html/.htaccess";
			if(file_exists($this->htaccess) && filesize($this->htaccess) > 0){
				$this->handle = fopen($this->htaccess, "r");
				$this->info = fread($this->handle, filesize($this->htaccess));
				if(eregi("\# IP Blocker(.+)\# End IP Blocker",$this->info,$this->blockedips)){
					$m = 0;
					$this->blockedips = explode("\ndeny from ",$this->blockedips[1]);
					for($k=0;$k<count($this->blockedips);$k++){
						$this->blockedips[$k] = explode("\n",$this->blockedips[$k]);
						$this->blockedips[$k] = $this->blockedips[$k][0];
						if(strlen($this->blockedips[$k])>5 && ip2long($this->blockedips[$k]) != -1 && ip2long($this->blockedips[$k]) !== false){
							$this->information[] = $this->blockedips[$k];
							$m++;
						}
					}
					$this->numofips[] = $m;
				} else {
					$this->numofips[] = 0;
				}
				fclose($this->handle);
			} else {
				$this->numofips[] = 0;
			}
		}
		if(strlen($this->information[count($this->information)-1]) == 0){
			unset($this->information[count($this->information)-1]);
		}
		$this->information = array_values(array_unique($this->information));
		if(count($this->domains)>1){
			for($l=0;$l<count($this->numofips);$l++){
				if($this->numofips[$l] != count($this->information)){
					$this->htaccess = $this->getuserdir."/domains/".$this->domains[$l]."/public_html/.htaccess";
					if(file_exists($this->htaccess) && filesize($this->htaccess) != 0){
						$this->handle = fopen($this->htaccess, "r");
						$this->info = fread($this->handle, filesize($this->htaccess));
						fclose($this->handle);
					} else {
						$this->info = "";
					}
					$this->handle = fopen($this->htaccess,"w+");
					if(eregi("\# IP Blocker(.+)\# End IP Blocker",$this->info)){
						$this->info = eregi_replace("\# IP Blocker\norder allow,deny(.+)\# End IP Blocker","# IP Blocker\norder allow,deny\ndeny from ".implode("\ndeny from ",$this->information)."\\1# End IP Blocker",$this->info);
						fwrite($this->handle,$this->info);
					} else {
						$this->info .= "\n# IP Blocker\norder allow,deny\ndeny from ".implode("\ndeny from ",$this->information)."\nallow from all\n# End IP Blocker";
						fwrite($this->handle,$this->info);
					}
					fclose($this->handle);
				}
			}
		}
		return $this->information;
	}
	function returnval(){
		print_r($this->information);
	}
}
?>
